<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">

  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>


  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


</head>

<body>
  <div class="container">
    <div class="text-center mt-2 mb-2">
      <h2>F120 - Quản trị Order </h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="voucherCodeInput">Loại Pizza </label>
        </div>
        <div class="col-sm-6">
          <select id="gPizzaTypeSelect" class="form-control">

          </select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-order" class="btn btn-info">Lọc dữ liệu</button>
        </div>
      </div>
    </div>

    <div class="container">
      <table class="table table-bordered table-striped table-hover" id="order-table">
        <thead>
          <tr>
            <th>STT </th>
            <th>Mã order</th>
            <th>Loại Pizza</th>
            <th>Tên khách hàng</th>
            <th>Ngày đặt hàng</th>
            <th>Trạng thái</th>
            <th>Action</th>
          </tr>
        </thead>
      </table>
    </div>

    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      // mảng orders
      var gOrderObjects = [
        {
          "id": 2,
          "orderCode": "12456",
          "gPizzaTypeId": 20,
          "customerName": "Do Van Linh",
          "date": "13/01/2021",
          "status": "completed"
        },
        {
          "id": 3,
          "orderCode": "22456",
          "gPizzaTypeId": 10,
          "customerName": "Huynh Van Nam",
          "date": "13/01/2021",
          "status": "new"
        },
        {
          "id": 4,
          "orderCode": "22986",
          "gPizzaTypeId": 15,
          "customerName": "Do Thi Lan",
          "date": "14/01/2021",
          "status": "completed"
        },
        {
          "id": 5,
          "orderCode": "42086",
          "gPizzaTypeId": 10,
          "customerName": "Dinh Chau Ngoc",
          "date": "14/01/2021",
          "status": "completed"
        },
        {
          "id": 6,
          "orderCode": "56086",
          "gPizzaTypeId": 15,
          "customerName": "Dang Tien Minh",
          "date": "15/01/2021",
          "status": "new"
        },
        {
          "id": 7,
          "orderCode": "90081",
          "gPizzaTypeId": 20,
          "customerName": "Do Hong Quan",
          "date": "15/01/2021",
          "status": "inprogress"
        },
        {
          "id": 8,
          "orderCode": "67012",
          "gPizzaTypeId": 15,
          "customerName": "Bui Thanh Phuoc",
          "date": "15/01/2021",
          "status": "inprogress"
        }
      ];

      // mảng pizza Type
      var gPizzaType = [
        {
          typeId: 10,
          typeName: "Hải Sản"
        },
        {
          typeId: 15,
          typeName: "Bò bít tết"
        },
        {
          typeId: 20,
          typeName: "Thịt gà"
        }
      ];

      const gCOL_NAME = ["id", "orderCode", "gPizzaTypeId", "customerName", "date", "status", "action"];
      const gID_COL = 0;
      const gORDER_CODE_COL = 1;
      const gPIZZA_TYPE_ID_COL = 2;
      const gCUSTOMER_NAME_COL = 3;
      const gDATE_COL = 4;
      const gSTATUS_COL = 5;
      const gACTION_COL = 6;
      var gStt = 1;



      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      $(document).ready(function () {
        onpageLoading();

        $("#btn-filter-order").on("click", function () {
          onBtnFilter();
        })
      })

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onpageLoading() {
        "use strict"
        $("#order-table").DataTable({
          data: gOrderObjects,
          columns: [
            { data: gCOL_NAME[gID_COL] },
            { data: gCOL_NAME[gORDER_CODE_COL] },
            { data: gCOL_NAME[gPIZZA_TYPE_ID_COL] },
            { data: gCOL_NAME[gCUSTOMER_NAME_COL] },
            { data: gCOL_NAME[gDATE_COL] },
            { data: gCOL_NAME[gSTATUS_COL] },
            { data: gCOL_NAME[gACTION_COL] },

          ],

          columnDefs: [
            {
              targets: gID_COL,
              render: chuyenId,
            },
            {
              targets: gPIZZA_TYPE_ID_COL,
              render: getPizzaNameByTypeId,

            },
            {
              targets: gACTION_COL,
              defaultContent: '<i class="mr-2 fas fa-edit "  style="color: #06e014; cursor: pointer;" title="Edit user"></i>' +
                '<i class="fas fa-trash-alt " style="color: #dc3309; cursor: pointer;" title="Delete"></i>'

            }

          ]
        })

        onpageLoadPizza();
      }
      // filter
      function onBtnFilter() {
        var vPizzaObj = {
          typeId: 0,
        }
        // b1 thu thap thong tin
        getDataPizza(vPizzaObj);
        console.log(vPizzaObj.typeId);
        // b2 validate(bo qua)
        // b3 xu ly
        var vArrayOrder = filterData(vPizzaObj);
        console.log(vArrayOrder);
        // b4 hien thi
        displayTable(vArrayOrder);
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      function onpageLoadPizza() {
        $("#gPizzaTypeSelect").append($("<option>", {
          value: 0,
          text: "Chọn loại pizza",
        }))

        for (var bI = 0; bI < gPizzaType.length; bI++) {
          $("#gPizzaTypeSelect").append($("<option>", {
            value: gPizzaType[bI].typeId,
            text: gPizzaType[bI].typeName,

          }))
        }
      }
      // thu thap thong tin
      function getDataPizza(paramObj) {
        paramObj.typeId = $("#gPizzaTypeSelect").val();
      }
      // b3 xu ly filter data
      function filterData(paramObj) {
        var vResult = [];
        vResult = gOrderObjects.filter(function (item) {
          return item.gPizzaTypeId == paramObj.typeId
        })


        return vResult;
      }
      // display table
      function displayTable(paramData) {
        "use strict "
        gStt = 1;
        var vTable = $("#order-table").DataTable();
        vTable.clear();
        vTable.rows.add(paramData);
        vTable.draw();
      }
      // hàm trả về pizzaTypeName dựa vào typeId
      function getPizzaNameByTypeId(paramTypeId) {
        "use strict";
        var vPizzaTypeName = "";
        var vIndex = 0;
        var vIsTypeFound = false;
        while (!vIsTypeFound && vIndex < gPizzaType.length) {
          if (gPizzaType[vIndex].typeId === paramTypeId) {
            vIsTypeFound = true;
            vPizzaTypeName = gPizzaType[vIndex].typeName;
          }
          else {
            vIndex++;
          }
        }
        return vPizzaTypeName;
      }
      function chuyenId() {
        return gStt++;
      }

    </script>
</body>

</html>